/***************************************************************************
 *            stp_timer.c
 *
 *  Wed Jun 15 18:06:52 2005
 *  Copyright  2005  trini
 *  trini4mail@yahoo.it
 *	franci.carbone@gmail.com
 ****************************************************************************/
 
#include "stp_timer.h"

/* 
 *	This code implements timer utilities functions
 *	
 */


/* Test if a timer is set active */
int
stp_is_timer_active(struct stp_timer *timer)
{	
	return ( timer->flag );
}

/* Start a timer from a timeout "value" to Zero */
void	
stp_start_timer(struct stp_timer *timer, uint16_t value)
{	
	timer->value = value;
	timer->flag = active;
}

/* Stop a timer setting its flag to "notactive" value */
void	
stp_stop_timer(struct stp_timer *timer)
{	
	timer->flag = notactive;
}

/* 	Test if a timer is expired , it returns 0 if timer isn't 
 *	expired or 1 in other cases 
 */
int
stp_timer_expired(struct stp_timer *timer)
{	if (stp_is_timer_active(timer))  {

		if (timer->value <= 0 ) 
			{
				timer->flag = notactive;
				return 1;
			}
		else	
			{	
				timer->value--;
				return 0;
			}
		}
	else return 0;
}

/* This function return the timeout values of a timer */
uint16_t	
stp_get_timer_value(struct stp_timer timer)
{	
	return (timer.value);
}
